part 'factory_helper.dart';
part 'floative_factory_impl.dart';

abstract class FloativeFactory {
  static FloativeFactory _instance;

  /// access to the Singleton instance of FloativeFactory
  static FloativeFactory get instance {
    _instance ??= _FloativeFactoryImpl();
    return _instance;
  }

  /// Short form to access the instance of FloativeFactory
  static FloativeFactory get I => instance;

  factory FloativeFactory.newInstance() {
    return _FloativeFactoryImpl();
  }

  T get<T>();
  void register<T>(Object instance, {bool overrideInstance = false});
  void registerLazySingleton<T>(Object instance);
  void dispose<T>();
}
