import 'package:flutter/foundation.dart';

import '../core/flavor/flavor.dart';
import '../core/floative_base/floative.dart';

class Logger {
  static void info(String message) {
    if (Floative.I.currentFlavor != Flavor.development) return;
    debugPrint('┌──────────────────────────');
    debugPrint('|        💡 info 💡       ');
    if (message == null) {
      var messageError = "| The instance of ${message.runtimeType} \n";
      messageError += "| is null            ";
      debugPrint(messageError);
    } else {
      debugPrint("| $message            ");
    }
    debugPrint('└──────────────────────────');
  }

  static void error(
      {String where,
      String function,
      Exception exception,
      List<dynamic> parameters}) {
    if (Floative.I.currentFlavor != Flavor.development) return;

    debugPrint('┌──────────────────────────────────────');
    debugPrint('|⛔ ⛔ ⛔ ⛔ ⛔ ⛔ ⛔ ⛔ ⛔ ⛔ ⛔ ⛔ ');
    debugPrint('|            FloativeLogger            ');
    debugPrint('| Hello, developer, there was an error ');
    debugPrint('|⛔ ⛔ ⛔ ⛔ ⛔ ⛔ ⛔ ⛔ ⛔ ⛔ ⛔ ⛔ ');

    if (where != null && where.isNotEmpty) {
      debugPrint('├┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄');
      debugPrint('| Where: $where');
    }

    if (function != null && function.isNotEmpty) {
      debugPrint('├┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄');
      debugPrint('| Function: $function');
    }

    if (exception != null) {
      debugPrint('├┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄');
      debugPrint('| Exception: $exception');
    }

    if (parameters != null && parameters.isNotEmpty) {
      debugPrint('├┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄┄');
      debugPrint('| Parameters:');
      for (var parameter in parameters) {
        debugPrint('| $parameter');
      }
    }

    debugPrint('└──────────────────────────');
  }
}
