part of '../ship.dart';

class _ShipNavigationObserver extends NavigatorObserver {
  Function(Route route, Route previousRoute) onPop;
  Function(Route route, Route previousRotue) onPush;
  Function(Route newRoute, Route oldRoute) onReplace;

  _ShipNavigationObserver({this.onPop, this.onPush, this.onReplace});

  @override
  void didPop(Route route, Route previousRoute) {
    super.didPop(route, previousRoute);
    if (onPop != null) {
      onPop(route, previousRoute);
    }
  }

  @override
  void didPush(Route route, Route previousRoute) {
    super.didPush(route, previousRoute);

    if (onPush != null) {
      onPush(route, previousRoute);
    }
  }

  @override
  void didReplace({Route newRoute, Route oldRoute}) {
    super.didReplace(newRoute: newRoute, oldRoute: oldRoute);

    if (onReplace != null) {
      onReplace(newRoute, oldRoute);
    }
  }
}
